using HslCommunication;
using Sln.Iot.PLC;
using Sln.Iot.Repository.service;
using Sln.Iot.Serilog;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using static System.Runtime.CompilerServices.RuntimeHelpers;

namespace Sln.Iot.Business
{
    public class RFID04Business
    {
        private Timer _timer;

        private readonly PLCConnect _plc = PLCConnect.Instance;

        private readonly SerilogHelper _log = SerilogHelper.Instance;

        public RFID04Business()
        {
            _timer = new Timer(TimerCallback, null, 0, 5000);
        }

        /// <summary>
        /// RFID04胶机2真空箱前数据处理流程
        /// </summary>
        /// <param name="state"></param>
        public void TimerCallback(object? state)
        {
            // 定时任务逻辑
            //读取信号
            OperateResult<short> signalRes = _plc.ReadInt16(_plc.DeltaInstance2, "D800");
            //成功验证
            if (signalRes.IsSuccess)
            {
                short signalValue = signalRes.Content;
                //如果有读取信号
                if (signalValue == 4001)
                {
                    //读取托盘码和产品码
                    OperateResult<byte[]> trayBytesResult = _plc.ReadBytes(_plc.DeltaInstance2, "D5000", 20);
                    //成功验证
                    if (trayBytesResult.IsSuccess)
                    {
                        //转换托盘吗
                        string traycode = Encoding.ASCII.GetString(trayBytesResult.Content);

                        //sql更新
                        bool res = TrayBindingService.Instance.UpDateTime(DateTime.Now.ToString(), traycode, "2");
                        if (!res)
                        {
                            _log.Error("胶机2真空箱前开始时间数据库写入异常");
                        }

                        //写入完成信号
                        res = _plc.PlcWrite(_plc.DeltaInstance2, "D800", 4002, DataTypeEnum.UInt16).IsSuccess;
                        if (!res)
                        {
                            _log.Error("胶机2真空箱前开始时间PLC写入完成信号异常");
                        }
                    }
                    //流程完成
                }

                if(signalValue == 4003)
                {
                    //读取托盘码
                    OperateResult<byte[]> trayBytesResult = _plc.ReadBytes(_plc.DeltaInstance2, "D5000", 20);
                    //成功验证
                    if (trayBytesResult.IsSuccess)
                    {
                        //转换托盘吗
                        string traycode = Encoding.ASCII.GetString(trayBytesResult.Content);

                        //sql更新
                        string nowTime = DateTime.Now.ToString();
                        bool res = TrayBindingService.Instance.UpDateTime(nowTime, traycode, "3");
                        if (!res)
                        {
                            _log.Error("胶机2真空箱前时间计算数据库写入异常");
                        }
                        //取之前存的时间
                        string time2 = TrayBindingService.Instance.GetTime2ByTrayCode(traycode);
                        //计算时间差
                        TimeSpan span = Convert.ToDateTime(time2) - Convert.ToDateTime(nowTime);
                        ushort spanSecond = (ushort)span.TotalSeconds;
                        res = _plc.PlcWrite(_plc.DeltaInstance2, "D810", spanSecond, DataTypeEnum.UInt16).IsSuccess;
                        if (!res)
                        {
                            _log.Error("胶机2真空箱前时间计算结果PLC写入异常");
                        }
                        //写入完成信号
                        res = _plc.PlcWrite(_plc.DeltaInstance2, "D800", 4004, DataTypeEnum.UInt16).IsSuccess;
                        if (!res)
                        {
                            _log.Error("胶机2真空箱前时间计算PLC写入完成信号异常");
                        }
                    }
                    //流程完成
                }
            }
            else
            {
                _log.Error("胶机2真空箱前开始时间读PLC取信号异常");
            }
        }
    }
}
